//****************************************************************************
// TreeCellEditorRenderer
// By PhilFlash
// http://philflash.inway.fr
//
// version 1.0 : 26 Janvier 2004
//   - version initiale
//
// Tests : - grand tree avec scroll => cliquez : vrifier la slection au bon endroit
//         - cliquez dans row vide => pas d'dition
//         - cliquez dans row vide  la fin du tree => dition dborde du tri ???
// TODO :
//  - onRollOver ne mets pas en surbrillance la colonne
//  - prvoir double-click pour dmarrer l'dition
//****************************************************************************

import mx.core.UIComponent;
import mx.controls.TextArea;
import TextField.StyleSheet;
import mx.controls.TextInput;
import mx.effects.Tween;

class TreeCellEditorRenderer extends UIComponent
{

	var myCell : TextField;

	var EDITORDEPTH : Number = 2000;	
	var cellEditor : MovieClip;		// an input field used for editing cells.
	var editorMask : MovieClip; 	// cosmetic - a mask to sweep in the cellEditor
	var editTween : Tween;			// a tween used to wipe the editorMask
	
	var owner; 						// The row that contains this cell
	var listOwner : MovieClip;   	// the reference we receive to the tree
	var getCellIndex : Function; 	// the function we receive from the tree
	var	getDataLabel : Function; 	// the function we receive from the tree
	
	var isRealCell: Boolean;
	
	function TreeCellEditorRenderer()
	{
	}

	// -----  -----
	// Modify this function for your own tree and your xml structure
	// Change the model
	function editField(index:Number, node:XMLNode, newData) : Void
	{
		// field for label
		var labelAttribute = getDataLabel();
		
		// Use your function here (WARNING if you use a labelFunction)
		var oldData = node.attributes[labelAttribute];		
		
		if (newData != oldData && newData != "") {
			node.attributes[labelAttribute] = newData;
		}
	}

	// -----  -----	
	function createChildren(Void) : Void
	{
		if (myCell == undefined)
		{
			createLabel("myCell", 1, {styleName:this});
		}
		myCell.border = false;
		myCell.styleName = listOwner;
		myCell.selectable = false;
		myCell.background = false;
		
		onPress = startPress		
		onRelease = startRelease;
		useHandCursor = false
	}
	
	
	function startPress()
	{
	}
	
	function startRelease()
	{
		var index = getCellIndex().itemIndex;	
		
		// Select row
		listOwner.selectedIndex = index;
		
		// A blank row is selected
		if (!isRealCell || listOwner.selectedNode == undefined) {
			return;
		}
		
		// Create editor
		if (cellEditor==undefined) {
			cellEditor = listOwner.createClassObject(mx.controls.TextInput, "editor_mc", EDITORDEPTH, {styleName:this, listOwner:this});
		}

		// for width
		var widthScroller = listOwner.vScroller.__width;
		
		// relative position in the tree
		var posList = index-listOwner.__vPosition;
		
		// Create editor 
		cellEditor.backgroundColor = 0xffffff;
		cellEditor._visible = true;
		cellEditor.setSize(__width-2, __height);
		cellEditor._x = listOwner.width - __width -  widthScroller;
		cellEditor._y = listOwner.rows[posList]._y;
		cellEditor.text = myCell.text;
		
		// Set up a mask for the editor
		editorMask = listOwner.attachMovie("BoundingBox", "editorMask", 60001, {_alpha:0});
		cellEditor.setMask(editorMask);
		editorMask._width = cellEditor.width;
		editorMask._height = cellEditor.height;
		editorMask._y = cellEditor._y;
		editorMask._x = cellEditor._x-editorMask._width;
		// Start the wipe - see onTweenUpdate/end for the results
		editTween = new mx.effects.Tween(this, cellEditor._x-editorMask._width, cellEditor._x, 250);

		cellEditor.addEventListener("keyDown", this.editorKeyDown);		
		
	}
	
	function editorKeyDown(Void) : Void
	{
		// ESC just kills the editor, no new data
		if (Key.isDown(Key.ESCAPE)) {
			listOwner.disposeEditor();
		} else if (Key.isDown(Key.ENTER)) {
			// ENTER edits the cell
			listOwner.editCell();
		}
	}
	
	function onMouseDown(Void) : Void
	{
		 // If you click away from an editable cell, then we need to store the new value and dispose it
		if (cellEditor._visible && !cellEditor.hitTest(_root._xmouse, _root._ymouse)) {
			editCell();
		}
	}
	
	// Take the stuff from the cellEditor, and store it in the dataProvider. Dispose the editor
	function editCell()
	{
		var selectedNode = listOwner.selectedNode;

		editField(getCellIndex().itemIndex, selectedNode, cellEditor.text);

		disposeEditor();
		
		// Refresh the view (special case here)
		listOwner.refresh(); // call updateControl
	}	

	function disposeEditor(Void) : Void
	{
		cellEditor.removeEventListener("keyDown", this.editorKeyDown);
		cellEditor._visible = false;
		delete cellEditor;
	}

	// -----  -----
	// Tween methods for the wipe effect on the editor
	function onTweenUpdate(val)
	{
		editorMask._x = val;
	}
	function onTweenEnd(val)
	{
		editorMask._x = val;
		cellEditor.setMask(undefined);
		editorMask.removeMovieClip();
	}
	
	// ----- Renderer methods -----
	// note that setSize is implemented by UIComponent and calls size(), after setting
	// __width and __height
	function size(Void) : Void
	{
		myCell.setSize(__width - 2, __height - 2);
	}

	function setValue(str:String, item:Object, sel:Boolean) : Void
	{
		isRealCell = (item == undefined ? false : true);
		myCell.text = str;
	}

	function getPreferredHeight(Void) : Number
	{
		return myCell.getPreferredHeight();
	}
}

